/* **
**      File : nrd_close.c
**      (C)1996-97  Mike Flouris.
**
**      Description : close device driver interface
**         for the nrd (Network RAM-Disk)
**
*/

int nrdclose(dev, flag, format)
dev_t dev;
int flag;
int format;
{
        /*
        ** dev : has the major - minor numbers ...
        ** flag : flags to determine if you wanna read or write ...
        ** format : used only for device drivers which are both
        **          block and character ...
        */

#ifdef NRDSPEED
        after = cycle_count();
	uprintf("Entering close : %d\n", after - before );

        before = cycle_count();
#endif

#ifdef NRDDEBUG
        if (flag && FREAD) 
                uprintf("NRD CLOSE major %d minor %d for reading\n", major(dev), minor(dev));
        else if (flag && FWRITE) 
                uprintf("NRD CLOSE major %d minor %d for writing\n", major(dev), minor(dev));
        else if (flag && FAPPEND)
                uprintf("NRD CLOSE major %d minor %d to append\n", major(dev), minor(dev));
        else 
                uprintf("NRD CLOSE major %d minor %d(flag = %d)\n", major(dev), minor(dev), flag);
#endif

	/*
	** Mark the device as closed ...
	*/
	if (! (open_nrd < 0) ) 
		open_nrd  = 0;
        else    {
		uprintf("Device already closed ...\n");
		return (ENXIO);
	}

#ifdef  WRITE_TO_LOCAL_DISK
	if(cdisk_close(makedev(DISK_MAJOR, DISK_MINOR), 0, 0) != ESUCCESS) {
		uprintf("Cdisk_close failed\n");
		return (EIO);
	}
#endif

#ifdef NRDDEBUG
                uprintf("Returning from nrdclose ...\n");
#endif

#ifdef NRDSPEED
        after = cycle_count();

        uprintf("Exiting close : %d\n", after - before );
	after = 0;
	before = 0;
#endif

        return (ESUCCESS);
}


