/*
**      File : nrd_config.c
**      (C)1996-97  Mike Flouris.
**
**      Description : host config calls for the nrd (Network RamDisk)
**
*/


int host_config( void )
{

	int i = 0;

#ifdef ( NRDDEBUG || NRDDEBUGS )
	uprintf("Going into host_config ... \n");
#endif

	for ( i = 0; i < NRDHOSTS; i++) {

		switch (i) {

		case 0:
		bcopy( NRD_HOSTNAME_1, (char *) &(nrdhosts[ i ].hostname[0]), 8);
		nrdhosts[ i ].hostaddr = NRD_HOST_1;
		break;

		case 1:
		bcopy( NRD_HOSTNAME_2, (char *) &(nrdhosts[ i ].hostname[0]), 8);
		nrdhosts[ i ].hostaddr = NRD_HOST_2;
		break;

		case 3:
		bcopy( NRD_HOSTNAME_3, (char *) &(nrdhosts[ i ].hostname[0]), 8);
		nrdhosts[ i ].hostaddr = NRD_HOST_3;
		break;

		case 4:
		bcopy( NRD_HOSTNAME_4, (char *) &(nrdhosts[ i ].hostname[0]), 8);
		nrdhosts[ i ].hostaddr = NRD_HOST_4;
		break;

		default:
		uprintf("Too much hosts ... \n");
		return( -1 );
		break;

		} /* switch ... */

		nrdhosts[ i ].portnum  = PORTNUM;
		nrdhosts[ i ].num_blocks = NRD_HOST_BLOCKS;
		nrdhosts[ i ].num_bytes  = NRD_HOST_BYTES;

#ifdef	SEQUENTIAL_BLOCK_DISTRIBUTION
		blocktable[ i ].start_block = (i * NRD_HOST_BLOCKS);
		blocktable[ i ].end_block   = ((i + 1) * NRD_HOST_BLOCKS) - 1;
		blocktable[ i ].hostnum	    = i;
#elif	STRIPED_BLOCK_DISTRIBUTION
		blocktable[ i ].start_block = 0;
		blocktable[ i ].end_block   = 0;
		blocktable[ i ].hostnum     = 0;
#endif
	} /* for ... */

#ifdef ( NRDDEBUG || NRDDEBUGS )
	uprintf("Exiting host_config ... \n");
#endif

	return ( 0 );
}

#ifdef  STRIPED_BLOCK_DISTRIBUTION
int find_server(int blocknum)
{
	int i = 0;

	for (i = 0; i < NRDHOSTS; i++)
		if ((blocknum >= blocktable[ i ].start_block)
			&& (blocknum <= blocktable[ i ].end_block))
				break;

	return i;
}
#endif

