/*
**
**      File : nrd_read.c
**      (C)1996-97  Mike Flouris.
**
**      Description : read device driver interface
**         for the nrd (Network RAM-Disk)
**
*/

int nrdread(dev, uio, flag)
dev_t dev;
struct uio * uio;
int flag;
{

	int i = 0;
	int server_no = 0, dbs = 0;
	Header req;
	char ack = 0;

#ifdef NRDSPEED
        after = cycle_count();
        uprintf("Entering read : %d\n", after - before );

        before = cycle_count();
#endif

#ifdef NRDDEBUG
	uprintf("NRD READ major(%d), minor(%d) ...\n", major(dev), minor(dev));
#endif

        /*
        ** Check if the device is open
        */
	if (! (open_nrd > 0) ) 
        	{
                uprintf("Error : Device not open ...\n");
                return (ENXIO);
        }


	/*
	** Satisfy the read request ...
	*/
        if ( uio->uio_rw != UIO_READ )
                uprintf("*** uio->uio_rw != UIO_READ \n");

	if ( (uio->uio_offset >= 0) && (uio->uio_resid >= 0) &&
	   (uio->uio_offset + uio->uio_resid) <= NRD_SIZE_BYTES) {

		/* Which server has the data ? */
#ifdef SEQUENTIAL_BLOCK_DISTRIBUTION
                server_no = ( uio->uio_offset / NRD_HOST_BYTES ) ;
#elif STRIPED_BLOCK_DISTRIBUTION
		server_no = find_server( ((uio->uio_offset / DEV_BSIZE) + 1) );
#endif

                req.type =     (NRD_REQ_BYTE_READ);                 /* Read request ... */
                req.blocknum = (uio->uio_resid);	 	    /* How many Bytes ??? */
                req.stblk =    ( uio->uio_offset % NRD_HOST_BYTES );/* Starting Byte ??? */


		/* Send the request to the server */
		if ( nrd_request( (Header *) &req, server_no ) )
			uprintf("Error sending request to server ...\n");


		/* Do the really hard stuff ... */
                nrd_rcv(nrdhosts[ server_no ].sockptr, uio->uio_iov->iov_base, uio->uio_resid, 0);

		uio->uio_iov->iov_base [ uio->uio_resid - 1 ] = 0;
		uio->uio_iovcnt = 1;
		if (uio->uio_iov->iov_base != NULL)
			uio->uio_iov->iov_len = strlen( uio->uio_iov->iov_base ) + 1;
		uio->uio_resid = 0;

	}
	else uprintf("NRD READ : Invalid address (%d + %d) ...\n", uio->uio_offset, uio->uio_resid);


	/*
	** Finish the I/O job and return to the syscall ...
	*/
#ifdef NRDSPEED
        after = cycle_count();

        uprintf("Exiting read : %d\n", after - before );
        before = cycle_count();
#endif

#ifdef NRDDEBUG
	uprintf("Returning from NRD READ ...\n");
#endif

	return (ESUCCESS);
}

	/*
	** End of Read ...... over .....
	*/

