
#include <stdio.h>
#include <unistd.h>
#include <fcntl.h>
#include <sys/stat.h>
#include <sys/types.h>
#include <sys/mman.h>
#include <errno.h>
#include <mach.h>
#include <sys/ioctl.h>


#include "nrd.h"

int main( int argc, char ** argv)
{
	int fd, use_queue = 0;

	if (argc == 1) use_queue = 1;
	else  {
		if (argc == 2) use_queue = atoi( argv[1] );
		else exit(0);
	}
	if ((use_queue != 1) && (use_queue != 0)) exit(0);

	if ( (fd = open("/dev/rnrd", O_RDWR, S_IRWXU)) == -1) {
		perror("Opening nrd");
		return 1;
	}

	if (use_queue) {
/*		printf("Sending nrduse_queue ...\n");*/
		if (ioctl(fd, NRD_IOCTL_QUEUE, NULL) < 0)
	              	 perror("ioctl (NRD_IOCTL_QUEUE)");
	} else {
/*		printf("Sending nrdsynch ...\n");*/
		if (ioctl(fd, NRD_IOCTL_NQUEUE, NULL) < 0)
	               	 perror("ioctl (NRD_IOCTL_NQUEUE)");
	}

	close (fd);

	return 0;
}


